!-----------------------------------------------------------------------------
!
! FACET
!
! The subroutine FACET calculates the aspect and the slope (positive
! downward) of the steepest direction within a given triangle (facet).
!
!-----------------------------------------------------------------------------

subroutine facet(e0,e1,e2,r,s_max_facet)

use mpar
implicit none

real(kind=4) pi
real(kind=4) s1,s2,e0,e1,e2,r,s_max_facet,sp,sd

pi=4*atan(1.0E0)

s1=(e0-e1)/delta_x ! delta_x=delta_y
s2=(e1-e2)/delta_x ! delta_x=delta_y
if (s1.eq.0.0E0) then
   if (s2.ge.0.0E0) then
      r=+pi/2 ! valore di comodo per s1=s2=0
   else ! if (s2.lt.0.0E0) then
      r=-pi/2
   end if
else
   r=atan(s2/s1)
end if
sp=sqrt(s1**2+s2**2)
sd=(e0-e2)/sqrt(delta_x**2+delta_y**2)

if (r.ge.0.and.r.le.pi/4.and.s1.ge.0.0E0) then
   s_max_facet=sp
else
   if (s1.gt.sd) then
      s_max_facet=s1
      r=0.0E0
   else
      s_max_facet=sd
      r=pi/4
   end if
end if

return
end subroutine facet
