!-----------------------------------------------------------------------------
!
! ISORT
!
! The subroutine ISORT (Inflow SORT) sort the uppermost cells of the links
! in the order of ascendinf logic number. The binary file ioi contains
! the number of recorded pointers in the first record and the pointers
! i_basin_io corresponding to the ascending link numbers link_number in
! the subsequent records.
!
!-----------------------------------------------------------------------------

subroutine isort()

use mpar
use mbbio
implicit none

integer(kind=4),allocatable :: i_basin_io(:),io(:)

integer(kind=4) i,j,i_basin,n_rec,i_io,l

allocate(i_basin_io(N_celle),io(N_celle))

! read the logical numbers, (here) io, from the binary files basin_b/bas

i_io=0
do i=1,N
   do j=1,M
      i_basin=(i-1)*M+j
      if (dtm_index_pr(i_basin) == 0) cycle
      i_io=i_io+1
      io(i_io)= dtm_link_number(i_basin)
      i_basin_io(i_io)=i_basin
   end do
end do

! sort cells in the order of ascending logical numbers using Quicksort

call qsort(N_celle,io,i_basin_io)

! open and write the binary file ioi 

open(17,file='ioi',access='direct',status='unknown',form='unformatted',recl=4)
n_rec=0
do l=1,N_celle ! ascending order
   if (io(l).gt.0) then
      n_rec=n_rec+1
      write(17,rec=n_rec+1) i_basin_io(l)
   end if
end do
write(17,rec=1) n_rec
close(17)

deallocate(i_basin_io,io)

return
end subroutine isort
